#ifndef CONTEXT_H
#define CONTEXT_H
#include "MMASSDefs.h"
#include <string>
#include <set>
#include <map>
#include <stdexcept>

namespace MMASS {
	using namespace std;

	class Context {
	public:
		class invalid_argument : public std::invalid_argument {
		public:
			invalid_argument(const string& msg = "") : std::invalid_argument(msg) {}
		};

	public:
		~Context();

		const size_t numOfAdjacentSites() const;
		const bool hasSite(const string &name) const;
		const string getSiteOfAgent(const string &name); // DEBUG ONLY

		const size_t numOfAdjacentAgents() const;
		const bool hasAgent(const string &name) const;
		spAgentInfo_set::const_iterator beginAdjacentAgents();
		spAgentInfo_set::const_iterator endAdjacentAgents();

		spSiteInfo getSite();

	protected:
		spSiteInfo        site;      // campo do sitio;
		spSiteInfo_set    adjSites;  // conjunto de campos adjacentes;
		spAgentInfo_set   adjAgents; // conjunto de nomes dos agentes adjacentes;
		//set<const string> adjSitesNames;  // conjunto de sitios adjacentes;

	private:
		Context(spSiteInfo site_, spSiteInfo_set &adjSites_, spAgentInfo_set &adjAgents_);

		static spContext createContext(spSiteInfo site_, spSiteInfo_set &adjSites_, spAgentInfo_set &adjAgents_);

		friend class Site;
	};
}

#endif