#include "stdafx.h"
#include "Context.h"
#include "Agent.h"
#include "Site.h"
using namespace MMASS;

Context::~Context() { }

const size_t Context::numOfAdjacentSites() const {
	return adjSites.size();
}

const bool Context::hasSite(const string &name) const {
	spSiteInfo_set::const_iterator info_i, i_end = adjSites.end();
	for (info_i = adjSites.begin(); info_i != i_end; ++info_i)
		if ((*info_i)->getSiteName() == name) break;

	return (info_i != i_end);
}

const string Context::getSiteOfAgent(const string &name) {
	spAgentInfo_set::const_iterator info_i, i_end = adjAgents.end();
	for (info_i = adjAgents.begin(); info_i != i_end; ++info_i)
		if ((*info_i)->getAgentName() == name) return (*info_i)->getSiteName();

	return "none";
}

const size_t Context::numOfAdjacentAgents() const {
	return adjAgents.size();
}

const bool Context::hasAgent(const string &name) const {
	spAgentInfo_set::const_iterator agent_i, a_end = adjAgents.end();
	for (agent_i = adjAgents.begin(); agent_i != a_end; ++agent_i)
		if ((*agent_i)->getAgentName() == name) return true;
	return false;
}

spAgentInfo_set::const_iterator Context::beginAdjacentAgents() {
	return adjAgents.begin();
}

spAgentInfo_set::const_iterator Context::endAdjacentAgents() {
	return adjAgents.end();
}

//void Context::addAdjacentAgent(spAgentInfo agInfo) {
//	adjAgents.insert(agInfo);
//}
//
//void Context::addAdjacentSite(spSiteInfo siteInfo) {
//	adjSites.insert(siteInfo);
//}

spSiteInfo Context::getSite() {
	return site;
}

spSiteInfo_set::const_iterator Context::beginAdjacentSites() {
	return adjSites.begin();
}

spSiteInfo_set::const_iterator Context::endAdjacentSites() {
	return adjSites.end();
}

Context::Context(spSiteInfo site_, spSiteInfo_set &adjSites_, spAgentInfo_set &adjAgents_) : site(site_), adjSites(adjSites_), adjAgents(adjAgents_) { }

spContext Context::createContext(spSiteInfo site_, spSiteInfo_set &adjSites_, spAgentInfo_set &adjAgents_) {
	return spContext(new Context(site_, adjSites_, adjAgents_));
}