#ifndef FIELD_H
#define FIELD_H

#ifdef MMASSDLL_EXPORTS
#define MMASSDLL_API __declspec(dllexport)
#else
#define MMASSDLL_API __declspec(dllimport)
#endif

#include "MMASSDefs.h"
#include <OgreNoMemoryMacros.h>
#include <string>

namespace MMASS {
	using std::string;

	class MMASSDLL_API Field {
	public:
		virtual ~Field() = 0;

		virtual spField createField(double value_) = 0;
		virtual double diffusion(spSite source, double generatedValue, spSite destiny) = 0;
		virtual double compose(double value1, double value2) = 0;
		virtual bool compare(double value1, double value2) = 0;

		virtual const string getIdentifier() = 0;

		double valuePerceivedForAgent(spAgent agent);
		double getValue();
		void setValue(double newValue);

	protected:
		double value;

		Field(double value_);

	private:
	};
}

#endif