#ifndef MMASSDEFS_H
#define MMASSDEFS_H

#ifdef MMASSDLL_EXPORTS
#define MMASSDLL_API __declspec(dllexport)
#else
#define MMASSDLL_API __declspec(dllimport)
#endif

#include <OgreNoMemoryMacros.h>
// http://www.boost.org/libs/smart_ptr/shared_ptr.htm
#include <boost/config.hpp>
#include <boost/weak_ptr.hpp>
#include <boost/shared_ptr.hpp>
#include <string>
#include <set>
#include <map>
// http://msdn2.microsoft.com/en-us/library/sa28fef8.aspx
#pragma warning( disable : 4290 )

namespace MMASS {
	class Field;
	class AgentInfo;
	class SiteInfo;
	class ActionInfo;
	class Action;
	class Context;
	class State;
	class Agent;
	class Site;
	class Space;
	class MASS;
	class CMMASS;

	typedef boost::shared_ptr<Field>      spField;
	typedef boost::weak_ptr<Field>        wpField;
	typedef boost::shared_ptr<AgentInfo>  spAgentInfo;
	typedef boost::weak_ptr<AgentInfo>    wpAgentInfo;
	typedef boost::shared_ptr<SiteInfo>   spSiteInfo;
	typedef boost::weak_ptr<SiteInfo>     wpSiteInfo;
	typedef boost::shared_ptr<ActionInfo> spActionInfo;
	typedef boost::weak_ptr<ActionInfo>   wpActionInfo;
	typedef boost::shared_ptr<Action>     spAction;
	typedef boost::weak_ptr<Action>       wpAction;
	typedef boost::shared_ptr<Context>    spContext;
	typedef boost::weak_ptr<Context>      wpContext;
	typedef boost::shared_ptr<State>      spState;
	typedef boost::weak_ptr<State>        wpState;
	typedef boost::shared_ptr<Agent>      spAgent;
	typedef boost::weak_ptr<Agent>        wpAgent;
	typedef boost::shared_ptr<Site>       spSite;
	typedef boost::weak_ptr<Site>         wpSite;
	typedef boost::shared_ptr<Space>      spSpace;
	typedef boost::weak_ptr<Space>        wpSpace;
	typedef boost::shared_ptr<MASS>       spMASS;
	typedef boost::weak_ptr<MASS>         wpMASS;
	typedef boost::shared_ptr<CMMASS>     spMMASS;
	typedef boost::weak_ptr<CMMASS>       wpMMASS;

	typedef std::set<spField>      spField_set;
	typedef std::set<spAgentInfo>  spAgentInfo_set;
	typedef std::set<wpAgentInfo>  wpAgentInfo_set;
	typedef std::set<spSiteInfo>   spSiteInfo_set;
	typedef std::set<spActionInfo> spActionInfo_set;
	typedef std::set<wpActionInfo> wpActionInfo_set;
	typedef std::set<spAgent>      spAgent_set;
	typedef std::set<wpAgent>      wpAgent_set;
	typedef std::set<spSite>       spSite_set;
	typedef std::set<wpSite>       wpSite_set;
	typedef std::set<spSpace>      spSpace_set;
	typedef std::set<wpSpace>      wpSpace_set;
	typedef std::set<spMASS>       spMASS_set;
	typedef std::set<wpMASS>       wpMASS_set;

	typedef std::map<const std::string, spField> spField_map;
	typedef std::map<const std::string, spAgent> spAgent_map;
	typedef std::map<const std::string, wpAgent> wpAgent_map;
	typedef std::map<const std::string, spSite>  spSite_map;
	typedef std::map<const std::string, wpSite>  wpSite_map;
	typedef std::map<const std::string, spSpace> spSpace_map;
	typedef std::map<const std::string, wpSpace> wpSpace_map;
	typedef std::map<const std::string, spMASS>  spMASS_map;
	typedef std::map<const std::string, wpMASS>  wpMASS_map;
}

#endif
