#ifndef STATE_H
#define STATE_H

#ifdef MMASSDLL_EXPORTS
#define MMASSDLL_API __declspec(dllexport)
#else
#define MMASSDLL_API __declspec(dllimport)
#endif

#include <pthread.h>
#include <OgreNoMemoryMacros.h>
#include "MMASSDefs.h"

namespace MMASS {
	template<class T>
	class MMASSDLL_API StateFactory {
		static spState createState() { return spState(new T()); }
	};

	class MMASSDLL_API State {
		// Deve ser criado uma subclasse deste!
	public:
		State();
		virtual ~State() = 0;

	private:
		State(const State&);
		State& operator=(const State&);
	};
}

#endif