#include "TestContext.h"
#include "../MMASSdll/Site.h"
#include "../MMASSdll/Space.h"
#include "../MMASSdll/MMASS.h"


void TestContext::run() {
	creatingContextTests();
}

void TestContext::creatingContextTests() {
	spSpace space = CMMASS::getSingleton()->getMASS("mass1")->getSpace();

	try {
		spSite site11 = space->getSite("site1.1");

		test_(site11->numOfAdjacentSites() == 3);
		test_(site11->isAdjacentTo("site1.2"));
		test_(site11->isAdjacentTo("site1.3"));
		test_(site11->isAdjacentTo("site1.7"));
		test_(!site11->isAdjacentTo("site1.1"));
		test_(!site11->isAdjacentTo("site1.4"));
		test_(!site11->isAdjacentTo("site1.5"));
		test_(!site11->isAdjacentTo("site1.6"));
		test_(!site11->isAdjacentTo("site1.8"));
		test_(!site11->isAdjacentTo("site1.9"));

		test_(space->getSite("site1.2")->getAgent()->getName() == "agent1.3");
		test_(space->getSite("site1.3")->getAgent()->getName() == "agent1.1");
		test_(!space->getSite("site1.7")->hasAgent());

		spContext context = site11->createContext();

		test_(context->numOfAdjacentSites() == 3);
		test_(context->hasSite("site1.2"));
		test_(context->hasSite("site1.3"));
		test_(context->hasSite("site1.7"));
		test_(!context->hasSite("site1.1"));
		test_(!context->hasSite("site1.4"));
		test_(!context->hasSite("site1.5"));
		test_(!context->hasSite("site1.6"));
		test_(!context->hasSite("site1.8"));
		test_(!context->hasSite("site1.9"));

		test_(context->numOfAdjacentAgents() == 2);
		test_(context->hasAgent("agent1.1"));
		test_(!context->hasAgent("agent1.2"));
		test_(context->hasAgent("agent1.3"));

		test_(context->getSiteOfAgent("agent1.1") == "site1.3");
		test_(context->getSiteOfAgent("agent1.3") == "site1.2");
	} catch (std::exception &e) {
		fail_(string("An unexpected exception have occured:\n")
			+ e.what());
	}
}